Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.jstacs.parameters
Class ParameterSetContainer

    java.lang.Object
      de.jstacs.AnnotatedEntity
          de.jstacs.parameters.Parameter
              de.jstacs.parameters.ParameterSetContainer

All Implemented Interfaces:
  GalaxyConvertible, Storable, Cloneable

    public class ParameterSetContainer

extends Parameter
implements GalaxyConvertible

Class for a `ParameterSetContainer` that contains a `ParameterSet` as value. This `ParameterSet` can be set either using the constructor or using the method `setValue(Object)` and can be obtained by the method `getValue()`. `ParameterSetContainer`s can be used to build tree-structures of `Parameter`s.

Author:
  Jan Grau, Jens Keilwagen

Field Summary
`protected String` | `errorMessage` The message of the last error or `null` if no error occurred.

Fields inherited from class de.jstacs.parameters.Parameter
`parent`

Fields inherited from class de.jstacs.AnnotatedEntity
`comment, datatype, name`

Constructor Summary
`ParameterSetContainer(Class<? extends ParameterSet> contentClazz)` Creates an new `ParameterSetContainer` out of the class of a `ParameterSet`.
`ParameterSetContainer(ParameterSet p)` Creates an new `ParameterSetContainer` out of a `ParameterSet`.
`ParameterSetContainer(StringBuffer representation)` The standard constructor for the interface `Storable`.
`ParameterSetContainer(String name, String comment, Class<? extends ParameterSet> contentClazz)` Creates an new `ParameterSetContainer` out of the class of a `ParameterSet`.
`ParameterSetContainer(String name, String comment, ParameterSet content)` Creates an new `ParameterSetContainer` out of a `ParameterSet`.

Method Summary
`protected void` | `appendFurtherInfos(StringBuffer buf)` This method can be used in the method `Storable.toXML()` to extract further information (name, comment, datatype).
`boolean` | `checkValue(Object value)` Checks the value for correctness, e.g. for numerical parameters this might be checking if the value is within specified bounds.
`ParameterSetContainer` | `clone()`
`protected void` | `extractFurtherInfos(StringBuffer representation)` This method can be used in the constructor with parameter `StringBuffer` to extract the further information.
`void` | `fromGalaxy(String namePrefix, StringBuffer command)` Parses the contents of `command` in the format defined by `configBuffer` of `GalaxyConvertible.toGalaxy(String, String, int, StringBuffer, StringBuffer)` and sets the values of the `Parameter` or `ParameterSet` accordingly.
`String` | `getErrorMessage()` If a value could not be set successfully this method returns the corresponding error message.
`ParameterSet` | `getValue()` Returns the value of the `AnnotatedEntity`.
`String` | `getXMLTag()` This method returns a tag used as outer tag of the XML description.
`boolean` | `hasDefaultOrIsSet()` Returns `true` if the parameter either has a default value or the value was set by the user, `false` otherwise.
`boolean` | `isAtomic()` Returns `true` if the parameter is of an atomic data type, `false` otherwise.
`boolean` | `isRequired()` Returns `true` if the `Parameter` is required, `false` otherwise.
`boolean` | `isSet()` Returns `true` if the parameter was set by the user, `false` otherwise.
`void` | `reset()` Resets the parameter and its contents to the default values or `null` if no defaults are given.
`void` | `setDefault(Object defaultValue)` Sets the default value of the `Parameter` to `defaultValue`.
`void` | `setValue(Object value)` Sets the value of this `Parameter` to `value`.
`void` | `toGalaxy(String namePrefix, String configPrefix, int depth, StringBuffer descBuffer, StringBuffer configBuffer)` Creates an Galaxy XML-representation of the parameters and appends it to `descBuffer` and variable configuration and appends it to `configBuffer`.

Methods inherited from class de.jstacs.parameters.Parameter
`getParent, isComparable, setParent`

Methods inherited from class de.jstacs.AnnotatedEntity
`getComment, getDatatype, getName, toXML`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### errorMessage

    protected String errorMessage

  The message of the last error or `null` if no error occurred.

Constructor Detail

### ParameterSetContainer

    public ParameterSetContainer(ParameterSet p)

  Creates an new `ParameterSetContainer` out of a `ParameterSet`.

  Parameters:
    `p` - the content of the `ParameterSetContainer` (the contained `ParameterSet`)
  See Also:
    `ParameterSet.getName(ParameterSet)`, `ParameterSet.getComment(ParameterSet)`

### ParameterSetContainer

    public ParameterSetContainer(String name,
                                 String comment,
                                 ParameterSet content)

  Creates an new `ParameterSetContainer` out of a `ParameterSet`.

  Parameters:
    `name` - the name of the `ParameterSetContainer`
    `comment` - a comment on the `ParameterSetContainer`
    `content` - the content of the `ParameterSetContainer` (the contained `ParameterSet`)

### ParameterSetContainer

    public ParameterSetContainer(Class<? extends ParameterSet> contentClazz)

  Creates an new `ParameterSetContainer` out of the class of a `ParameterSet`.

  Parameters:
    `contentClazz` - the class of the contained `ParameterSet`
  See Also:
    `ParameterSet.getName(Class)`, `ParameterSet.getComment(Class)`

### ParameterSetContainer

    public ParameterSetContainer(String name,
                                 String comment,
                                 Class<? extends ParameterSet> contentClazz)

  Creates an new `ParameterSetContainer` out of the class of a `ParameterSet`.

  Parameters:
    `name` - the name of the `ParameterSetContainer`
    `comment` - a comment on the `ParameterSetContainer`
    `contentClazz` - the class of the contained `ParameterSet`

### ParameterSetContainer

    public ParameterSetContainer(StringBuffer representation)
                          throws NonParsableException

  The standard constructor for the interface `Storable`. Creates a new `ParameterSetContainer` from its XML representation.

  Parameters:
    `representation` - the XML representation as `StringBuffer`
  Throws:
    `NonParsableException` - if the `StringBuffer` `representation` could not be parsed

Method Detail

### clone

    public ParameterSetContainer clone()
                                throws CloneNotSupportedException

  Overrides:
    `clone` in class `Parameter`
  Throws:
    `CloneNotSupportedException`

### isRequired

    public boolean isRequired()

  Description copied from class: `Parameter`
  Returns `true` if the `Parameter` is required, `false` otherwise.

  Specified by:
    `isRequired` in class `Parameter`
  Returns:
    `true` if the `Parameter` is required, `false` otherwise

### checkValue

    public boolean checkValue(Object value)

  Description copied from class: `Parameter`
  Checks the value for correctness, e.g. for numerical parameters this might be checking if the value is within specified bounds.

  Specified by:
    `checkValue` in class `Parameter`
  Parameters:
    `value` - the value to be checked
  Returns:
    `true` if the value is valid, `false` otherwise

### setValue

    public void setValue(Object value)
                  throws SimpleParameter.IllegalValueException

  Description copied from class: `Parameter`
  Sets the value of this `Parameter` to `value`.

  Specified by:
    `setValue` in class `Parameter`
  Parameters:
    `value` - the new value of the `Parameter`
  Throws:
    `SimpleParameter.IllegalValueException` - if the specified value is not valid for this `Parameter`

### getValue

    public ParameterSet getValue()

  Description copied from class: `AnnotatedEntity`
  Returns the value of the `AnnotatedEntity`.

  Specified by:
    `getValue` in class `AnnotatedEntity`
  Returns:
    the value of the `AnnotatedEntity`

### hasDefaultOrIsSet

    public boolean hasDefaultOrIsSet()

  Description copied from class: `Parameter`
  Returns `true` if the parameter either has a default value or the value was set by the user, `false` otherwise.

  Specified by:
    `hasDefaultOrIsSet` in class `Parameter`
  Returns:
    `true` if value has a default value or was set, `false` otherwise

### isSet

    public boolean isSet()

  Description copied from class: `Parameter`
  Returns `true` if the parameter was set by the user, `false` otherwise.

  Specified by:
    `isSet` in class `Parameter`
  Returns:
    `true` if the parameter was set, `false` otherwise

### isAtomic

    public boolean isAtomic()

  Description copied from class: `Parameter`
  Returns `true` if the parameter is of an atomic data type, `false` otherwise.

  Specified by:
    `isAtomic` in class `Parameter`
  Returns:
    `true` if the parameter is atomic, `false` otherwise

### getErrorMessage

    public String getErrorMessage()

  Description copied from class: `Parameter`
  If a value could not be set successfully this method returns the corresponding error message.

  Specified by:
    `getErrorMessage` in class `Parameter`
  Returns:
    an error message if a value could not be set successfully

### reset

    public void reset()

  Description copied from class: `Parameter`
  Resets the parameter and its contents to the default values or `null` if no defaults are given.

  Specified by:
    `reset` in class `Parameter`

### setDefault

    public void setDefault(Object defaultValue)
                    throws Exception

  Description copied from class: `Parameter`
  Sets the default value of the `Parameter` to `defaultValue`. This method also sets the current value of this `Parameter` to the default.

  Specified by:
    `setDefault` in class `Parameter`
  Parameters:
    `defaultValue` - the default value
  Throws:
    `Exception` - if the default value is not an appropriate value for this `Parameter`

### getXMLTag

    public String getXMLTag()

  Description copied from class: `AnnotatedEntity`
  This method returns a tag used as outer tag of the XML description.

  Specified by:
    `getXMLTag` in class `AnnotatedEntity`
  Returns:
    a tag used as outer tag of the XML description

### appendFurtherInfos

    protected void appendFurtherInfos(StringBuffer buf)

  Description copied from class: `AnnotatedEntity`
  This method can be used in the method `Storable.toXML()` to extract further information (name, comment, datatype).

  Overrides:
    `appendFurtherInfos` in class `Parameter`
  Parameters:
    `buf` - a XML representation of the main information as `StringBuffer`
  See Also:
    `Storable.toXML()`

### extractFurtherInfos

    protected void extractFurtherInfos(StringBuffer representation)
                                throws NonParsableException

  Description copied from class: `AnnotatedEntity`
  This method can be used in the constructor with parameter `StringBuffer` to extract the further information.

  Overrides:
    `extractFurtherInfos` in class `Parameter`
  Parameters:
    `representation` - a XML represenation of the main information as `StringBuffer`
  Throws:
    `NonParsableException` - if the XML representation is not parsable
  See Also:
    `AnnotatedEntity.AnnotatedEntity(StringBuffer)`

### toGalaxy

    public void toGalaxy(String namePrefix,
                         String configPrefix,
                         int depth,
                         StringBuffer descBuffer,
                         StringBuffer configBuffer)
                  throws Exception

  Description copied from interface: `GalaxyConvertible`
  Creates an Galaxy XML-representation of the parameters and appends it to `descBuffer` and variable configuration and appends it to `configBuffer`. The variable configuation is also used to parse user-supplied values returned by Galaxy.

  Specified by:
    `toGalaxy` in interface `GalaxyConvertible`
  Parameters:
    `namePrefix` - the prefix of the variable name used in Galaxy
    `configPrefix` - the prefix for conditionals
    `depth` - the depth in the parameter hierarchy, used for graphical representation of nesting
    `descBuffer` - the buffer for the parameter description
    `configBuffer` - the buffer for the configuration line
  Throws:
    `Exception` - if the conversion fails

### fromGalaxy

    public void fromGalaxy(String namePrefix,
                           StringBuffer command)
                    throws Exception

  Description copied from interface: `GalaxyConvertible`
  Parses the contents of `command` in the format defined by `configBuffer` of `GalaxyConvertible.toGalaxy(String, String, int, StringBuffer, StringBuffer)` and sets the values of the `Parameter` or `ParameterSet` accordingly.

  Specified by:
    `fromGalaxy` in interface `GalaxyConvertible`
  Parameters:
    `namePrefix` - the prefix of the variable name
    `command` - the command string
  Throws:
    `Exception` - if the command string could not be parsed

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD